Attribute VB_Name = "mGeneral"
Enum datFormat
    datText = 0
    datHex = 1
    datBinary = 2
    datNumber = 3
End Enum

Dim header(33) As Integer
Dim bhw As Integer

Dim program(10000) As Integer
Dim bpw As Integer

Dim info(10000) As Integer
Dim biw As Integer

Dim cAddr, lAddr, lChar As Integer
Global BuildIt As Boolean
Dim errCount As Integer
Dim tmpsize As Integer
Dim cExit, fMZ As Boolean

Dim labAddr(100) As Integer
Dim labName(100) As String
Dim labCount As Integer

Dim varAddr(100) As Integer
Dim varName(100) As String
Dim varCount As Integer

Public Const GENERIC_WRITE = &H40000000
Public Const GENERIC_READ = &H80000000
Const FILE_ATTRIBUTE_NORMAL = &H80
Const CREATE_ALWAYS = 2
Const OPEN_ALWAYS = 4
Const INVALID_HANDLE_VALUE = -1

Declare Function ReadFile Lib "kernel32" (ByVal hFile As Long, _
  lpBuffer As Any, ByVal nNumberOfBytesToRead As Long, _
  lpNumberOfBytesRead As Long, ByVal lpOverlapped As Long) As Long

Private Declare Function CloseHandle Lib "kernel32" ( _
  ByVal hObject As Long) As Long

Private Declare Function WriteFile Lib "kernel32" _
  (ByVal hFile As Long, lpBuffer As _
  Any, ByVal nNumberOfBytesToWrite As _
  Long, lpNumberOfBytesWritten As Long, ByVal lpOverlapped As Long) As Long

Private Declare Function CreateFile Lib "kernel32" _
  Alias "CreateFileA" (ByVal lpFileName As String, _
  ByVal dwDesiredAccess As Long, ByVal dwShareMode As Long, _
  ByVal lpSecurityAttributes As Long, _
  ByVal dwCreationDisposition As Long, _
  ByVal dwFlagsAndAttributes As Long, ByVal hTemplateFile As Long) _
  As Long

Declare Function FlushFileBuffers Lib "kernel32" ( _
  ByVal hFile As Long) As Long

Sub WriteToFile(fname As String)
    Dim fHandle As Long
    Dim fSuccess As Long
    Dim lBytesWritten As Long
    Dim BytesToWrite As Long
    Dim i As Integer
    If BuildIt Then
        BytesToWrite = 1
        fHandle = CreateFile(fname, GENERIC_WRITE Or GENERIC_READ, _
                             0, 0, OPEN_ALWAYS, FILE_ATTRIBUTE_NORMAL, 0)
        If fHandle <> INVALID_HANDLE_VALUE Then
           For i = 0 To bhw - 1
             fSuccess = WriteFile(fHandle, header(i), _
                         BytesToWrite, lBytesWritten, 0)
           Next i
           For i = 0 To bpw - 1
             fSuccess = WriteFile(fHandle, program(i), _
                         BytesToWrite, lBytesWritten, 0)
           Next i
           For i = 0 To biw - 1
             fSuccess = WriteFile(fHandle, info(i), _
                         BytesToWrite, lBytesWritten, 0)
           Next i
           If fSuccess <> 0 Then
              fSuccess = FlushFileBuffers(fHandle)
              fSuccess = CloseHandle(fHandle)
           End If
        End If
    Else
        AddError "Could not complete the compilation process!", 0
    End If
End Sub

Public Sub AddListItem(Text)
    fMain.log.AddItem Text
End Sub

Public Sub Make(Filen As String)
    bhw = 0
    biw = 0
    bpw = 0
    BuildIt = True
    errCount = 0
    cAddr = 0
    lAddr = 0
    lChar = 0
    tmpsize = 0
    labCount = 0
    varCount = 0
    fMZ = False
    cExit = False
    If Fileexists(Filen) Then Kill Filen
    AddListItem "Compiling " & GetFileTitle(Filen) & "..."
    Compile
    WriteToFile Filen
    WriteSummary fMain.cdlMake.Filename
End Sub

Public Function GetFileTitle(Filename)
    On Error Resume Next
    GetFileTitle = Right(Filename, Len(Filename) - InStrRev(Filename, "\"))
End Function

Public Sub AddByte(A As Integer)
    program(bpw) = A
    bpw = bpw + 1
End Sub

Public Sub AddWord(A As Integer, B As Integer)
    AddByte B
    AddByte A
End Sub

Public Sub AddDWord(A As Integer, B As Integer, C As Integer, D As Integer)
    AddByte D
    AddByte C
    AddByte B
    AddByte A
End Sub

Public Sub AddBinary(str As String)
    AddByte Bin2Int(str)
End Sub

Public Sub AddHex(str As String)
    AddByte CInt("&H" & str)
End Sub

Public Sub AddHexs(str As String)
    Dim i As Integer
    i = 1
    Do While i < Len(str)
        AddByte CInt("&H" & Mid(str, i, 2))
        i = i + 2
    Loop
End Sub

Public Sub AddString(str As String)
    Dim i As Integer
    For i = 1 To Len(str)
        AddByte Asc(Mid(str, i, 1))
    Next i
End Sub

Function Bin2Int(B As String) As Integer
    Dim o As Long, i As Integer
    o = 0
    For i = Len(B) To 1 Step -1
        If Mid(B, i, 1) = "1" Then
            o = o + 2 ^ (Len(B) - i)
        End If
    Next i
    Bin2Int = o
End Function

Public Sub WriteHeader()
    bhw = 34
    header(0) = &H4D
    header(1) = &H5A
    header(2) = bhw + bpw + biw
    header(3) = &H0
    header(4) = &H1
    header(5) = &H0
    header(6) = &H0
    header(7) = &H0
    header(8) = &H2
    header(9) = &H0
    header(10) = &H0
    header(11) = &H1
    header(12) = &HFF
    header(13) = &HFF
    header(14) = &H7
    header(15) = &H0
    header(16) = &H0
    header(17) = &H10
    header(18) = &H0
    header(19) = &H0
    header(20) = &H0
    header(21) = &H0
    header(22) = &H0
    header(23) = &H0
    header(24) = &H1C
    header(25) = &H0
    header(26) = &H0
    header(27) = &H0
    header(28) = &H0
    header(29) = &H0
    header(30) = &H0
    header(31) = &H0
    header(32) = &HE
    header(33) = &H1F
End Sub

Public Sub AddData(Dat As String, Format As datFormat)
    Dim i As Integer
    cAddr = biw
    Select Case Format
        Case datText
            For i = 1 To Len(Dat)
                AddDataByte Asc(Mid(Dat, i, 1))
            Next i
        Case datHex
            i = 1
            Do While i < Len(Dat)
                AddDataByte CInt("&H" & Mid(Dat, i, 2))
                i = i + 2
            Loop
        Case datBinary
            AddDataByte Bin2Int(Dat)
        Case datNumber
            AddDataByte CInt(Dat)
    End Select
End Sub

Public Sub AddDataC(Count As Integer)
    Dim i As Integer
    cAddr = biw
    For i = 0 To Count - 1
        AddDataByte Asc("$")
    Next i
End Sub

Public Sub AddDataByte(A As Integer)
    info(biw) = A
    biw = biw + 1
End Sub

Public Sub Compile()
    On Error GoTo err
    Dim i As Integer
    Dim ic As Integer
    Dim pc() As String
    
    For i = 1 To fMain.lst.ListItems.Count
        Select Case LCase(fMain.lst.ListItems(i).Text)
            Case "format"
                If UCase(fMain.lst.ListItems(i).ListSubItems(1).Text) = "MZ" Then
                    fMZ = True
                End If
            Case "writeln"
                tmpsize = tmpsize + 7
                If fMain.lst.ListItems(i).ListSubItems(1).Text = "" Then AddError "The function 'WriteLn' requires a parameter", i
            Case "write"
                tmpsize = tmpsize + 7
                If fMain.lst.ListItems(i).ListSubItems(1).Text = "" Then AddError "The function 'WriteLn' requires a parameter", i
            Case "newline"
                tmpsize = tmpsize + 12
            Case "read"
                tmpsize = tmpsize + 19
            Case "readln"
                tmpsize = tmpsize + 26
                If fMain.lst.ListItems(i).ListSubItems(1).Text = "" Then AddError "The function 'ReadLn' requires a parameter", i
            Case "wait"
                tmpsize = tmpsize + 4
            Case "ifchar equ"
                tmpsize = tmpsize + 7
            Case "label"
                If fMain.lst.ListItems(i).ListSubItems(1).Text = "" Then
                    AddError "The function 'Label' requires a parameter", i
                Else
                    AddLabel LCase(Trim(fMain.lst.ListItems(i).ListSubItems(1).Text))
                End If
            Case "goto"
                tmpsize = tmpsize + 2
                If fMain.lst.ListItems(i).ListSubItems(1).Text = "" Then AddError "The function 'Goto' requires a parameter", i
            Case "gotoxy"
                tmpsize = tmpsize + 10
            Case "colortext"
                tmpsize = tmpsize + 22
            Case "colortextex"
                tmpsize = tmpsize + 20
            Case "clear"
                tmpsize = tmpsize + 26
            Case "aliass"
                If fMain.lst.ListItems(i).ListSubItems(1).Text = "" Then AddError "The function 'AliasS' requires a parameter", i
            Case "aliasc"
                If fMain.lst.ListItems(i).ListSubItems(1).Text = "" Then AddError "The function 'AliasC' requires a parameter", i
            Case "file"
                If fMain.lst.ListItems(i).ListSubItems(1).Text = "" Then AddError "The function 'File' requires a parameter", i
            Case "exit"
                tmpsize = tmpsize + 5
                cExit = True
        End Select
    Next i
    
    If Not cExit Then
        AddError "Can't find end of program (Hint: Exit-function)", 0
    End If
    
    For i = 1 To fMain.lst.ListItems.Count
        Select Case LCase(fMain.lst.ListItems(i).Text)
            Case "variable"
                If InStr(fMain.lst.ListItems(i).ListSubItems(1).Text, ",") = False Then
                    AddError "The function 'Variable' requires two parameters", i
                Else
                    pc = Split(fMain.lst.ListItems(i).ListSubItems(1).Text, ",")
                    AddData GetValue(pc(1), ""), datText
                    AddVariable pc(0)
                End If
        End Select
    Next i

    For i = 1 To fMain.lst.ListItems.Count
        If Left(fMain.lst.ListItems(i).Text, 2) <> "//" Then
        Select Case LCase(fMain.lst.ListItems(i).Text)
            Case "format"
                ' Set output format
            Case "writeln"
                If InStr(fMain.lst.ListItems(i).ListSubItems(1).Text, "$") Then AddError "Parameter cannot contain a '$-character'", i
                If Left(fMain.lst.ListItems(i).ListSubItems(1).Text, 1) = "@" Then
                    ' mov ah,09h
                    ' mov dx,Variable
                    ' int 21h
                    AddHex "BA"
                    AddWord 0, GetVariable(Right(fMain.lst.ListItems(i).ListSubItems(1).Text, Len(fMain.lst.ListItems(i).ListSubItems(1).Text) - 1), i)
                    AddHexs "B409CD21"
                Else
                    ' mov ah,09h
                    ' mov dx,String
                    ' int 21h
                    AddHex "BA"
                    AddData GetValue(fMain.lst.ListItems(i).ListSubItems(1).Text, vbCrLf), datText
                    AddWord 0, cAddr + tmpsize + 2
                    AddHexs "B409CD21"
                End If
            Case "write"
                If InStr(fMain.lst.ListItems(i).ListSubItems(1).Text, "$") Then AddError "Parameter cannot contain a '$-character'", i
                If Left(fMain.lst.ListItems(i).ListSubItems(1).Text, 1) = "@" Then
                    ' mov ah,09h
                    ' mov dx,Variable
                    ' int 21h
                    AddHex "BA"
                    AddWord 0, GetVariable(Right(fMain.lst.ListItems(i).ListSubItems(1).Text, Len(fMain.lst.ListItems(i).ListSubItems(1).Text) - 1), i)
                    AddHexs "B409CD21"
                Else
                    ' mov ah,09h
                    ' mov dx,String
                    ' int 21h
                    AddHex "BA"
                    AddData GetValue(fMain.lst.ListItems(i).ListSubItems(1).Text, ""), datText
                    AddWord 0, cAddr + tmpsize + 2
                    AddHexs "B409CD21"
                End If
            Case "newline"
                ' mov ah,02h
                ' mov dl,0Dh
                ' int 21h
                ' mov ah,02h
                ' mov dl,0Ah
                ' int 21h
                AddHexs "B402B20DCD21B402B20ACD21"
            Case "read"
                ' mov ah,01h
                ' int 21h
                ' mov [lastchar],al
                ' mov ah,02h
                ' mov dl,0Dh
                ' int 21h
                ' mov ah,02h
                ' mov dl,0Ah
                ' int 21h
                AddHexs "B401CD21A2"
                lChar = cAddr
                AddData "00", datHex
                AddWord 0, lChar + tmpsize + 34
                AddHexs "B402B20DCD21B402B20ACD21"
            Case "readln"
                ' mov ah,0Ah
                ' mov dx,LastInput
                ' int 21h
                ' push ds
                ' pop es
                ' mov di,string
                ' mov al,0Dh
                ' repne scasb
                ' mov byte [di-1],'$'
                ' mov ah,02h
                ' mov dl,0Ah
                ' int 21h
                AddHex "BA"
                AddData fMain.lst.ListItems(i).ListSubItems(1).Text, datNumber
                lAddr = cAddr
                AddData "00", datHex
                AddDataC CInt(fMain.lst.ListItems(i).ListSubItems(1).Text) + 1
                AddByte lAddr + tmpsize + 2
                AddHexs "00B40ACD21"
                AddHexs "1E07BF"
                AddByte lAddr + tmpsize + 2
                AddHexs "00B00DF2AEC645FF24"
                AddHexs "B402B20ACD21"
            Case "wait"
                ' xor ax,ax
                ' int 16h
                AddHexs "31C0CD16"
            Case "ifchar equ"
                ' cmp varChar,Char
                ' je Label
                pc = Split(fMain.lst.ListItems(i).ListSubItems(1).Text, ",")
                If UBound(pc) <> 2 Then AddError "The function 'IfChar Equ' requires three parameter", i
                AddHexs "803E"
                AddByte GetVariable(Right(pc(1), Len(pc(1)) - 1), i) + 32
                AddHex "00"
                AddByte Asc(pc(0))
                AddHex "74"
                AddByte GetLabel(pc(2), i) - bpw - 1
            Case "label"
                ' Label:
            Case "goto"
                ' jmp Label
                AddHex "EB"
                AddByte GetLabel(fMain.lst.ListItems(i).ListSubItems(1).Text, i) - bpw - 1
            Case "gotoxy"
                ' mov ah,2
                ' mov dh,Y
                ' mov dl,X
                ' mov bh,0
                ' int 10h
                pc = Split(fMain.lst.ListItems(i).ListSubItems(1).Text, ",")
                If UBound(pc) <> 1 Then AddError "The function 'GotoXY' requires two parameter", i
                AddHexs "B402B6"
                AddByte CInt(pc(1))
                AddHex "B2"
                AddByte CInt(pc(0))
                AddHexs "B700CD10"
            Case "colortext"
                ' mov ah,13h
                ' mov al,1
                ' mov bh,0
                ' mov bl,Color
                ' mov cx,len(String)
                ' mov dh,Y
                ' mov dl,X
                ' push cs
                ' pop es
                ' mov bp,String
                ' int 10h
                pc = Split(fMain.lst.ListItems(i).ListSubItems(1).Text, ",")
                If UBound(pc) <> 3 Then AddError "The function 'ColorText' requires four parameter", i
                AddHexs "B413B001B700B3"
                AddByte CInt(pc(1))
                AddHex "B9"
                AddWord 0, Len(pc(0))
                AddHexs "B6"
                AddByte CInt(pc(3))
                AddHex "B2"
                AddByte CInt(pc(2))
                AddHexs "0E07BD"
                AddData pc(0), datText
                AddWord 0, cAddr + tmpsize + 2
                AddHexs "CD10"
            Case "colortextex"
                ' mov ah,13h
                ' mov al,3
                ' mov bh,0
                ' mov cx,len(String)
                ' mov dh,Y
                ' mov dl,X
                ' push cs
                ' pop es
                ' mov bp,String
                ' int 10h
                pc = Split(fMain.lst.ListItems(i).ListSubItems(1).Text, ",")
                If UBound(pc) <> 2 Then AddError "The function 'ColorTextEx' requires three parameter", i
                AddHexs "B413B003B700"
                AddHex "B9"
                AddWord 0, Len(pc(0)) / 2
                AddHexs "B6"
                AddByte CInt(pc(2))
                AddHex "B2"
                AddByte CInt(pc(1))
                AddHexs "0E07BD"
                AddData pc(0), datText
                AddWord 0, cAddr + tmpsize + 2
                AddHexs "CD10"
            Case "clear"
                ' mov ah,6
                ' mov ch,0
                ' mov cl,0
                ' mov dh,24
                ' mov dl,79
                ' mov bh,7
                ' mov al,0
                ' int 10h
                ' mov ah,2
                ' mov dh,0
                ' mov dl,0
                ' mov bh,0
                ' int 10h
                AddHexs "B406B500B100B618B24FB707B000CD10B402B600B200B700CD10"
            Case "variable"
                ' varName db 'Param'
            Case "exit"
                ' mov ax,4C00h
                ' int 21h
                AddHexs "B8004CCD21"
            Case "aliass"
                varName(varCount) = fMain.lst.ListItems(i).ListSubItems(1).Text
                varAddr(varCount) = tmpsize + lAddr + 4
                varCount = varCount + 1
            Case "aliasc"
                varName(varCount) = fMain.lst.ListItems(i).ListSubItems(1).Text
                varAddr(varCount) = tmpsize + lChar + 2
                varCount = varCount + 1
            Case "file"
                ' Set output file
            Case Else
                AddError "Invalid command (" & fMain.lst.ListItems(i).Text & ")", i
        End Select
        End If
    Next i
    If fMZ Then WriteHeader
    Exit Sub
    
err:
    AddError "Unknown error!", 0
End Sub

Public Function SaveFile(lzFile As String, StrData As String)
Dim tFile As Long
  If Fileexists(lzFile) Then Kill lzFile
  tFile = FreeFile
  Open lzFile For Binary Access Write As #tFile
      Put #tFile, , StrData
  Close #tFile
End Function
Public Function OpenFile(lzFile As String) As String
Dim tFile As Long
Dim StrBuff As String, FileToOpen As String

  tFile = FreeFile
  Open lzFile For Binary Access Read As #tFile
      StrBuff = Space(LOF(tFile))
      Get #tFile, , StrBuff
  Close #tFile
  OpenFile = StrBuff
  StrBuff = ""
End Function

Public Function GetValue(str As String, extra As String)
    GetValue = str & extra & "$"
End Function

Public Sub AddError(Text As String, Line As Integer)
    If Line <> 0 Then
        AddListItem "Error (line: " & Line & "): " & Text
        fMain.lst.ListItems(Line).Selected = True
        fMain.lst.SetFocus
    Else
        AddListItem "Error: " & Text
    End If
    BuildIt = False
    errCount = errCount + 1
End Sub

Function Fileexists(fname) As Boolean
    If Dir(fname) <> "" Then _
    Fileexists = True _
    Else Fileexists = False
End Function

Public Sub WriteSummary(Filename)
    If errCount = 0 Then
        AddListItem "Completed with no errors. " & FileLen(Filename) & " bytes written."
    Else
        AddListItem "Completed with " & errCount & " errors. No file created!"
    End If
End Sub

Public Function GetLabel(LabelText As String, CLine As Integer) As Integer
    Dim i As Integer
    Dim lFound As Boolean
    
    For i = 0 To labCount
        If labName(i) = LabelText Then
            GetLabel = labAddr(i)
            lFound = True
        End If
    Next i
    If Not lFound Then
        AddError "Unknown label: " & LabelText & "...", CLine
        GetLabel = 0
    End If
End Function

Public Sub AddLabel(Name As String)
    labName(labCount) = Name
    labAddr(labCount) = tmpsize
    labCount = labCount + 1
End Sub

Public Function GetVariable(VariableName As String, CLine As Integer) As Integer
    Dim i As Integer
    Dim lFound As Boolean
    
    For i = 0 To varCount
        If varName(i) = VariableName Then
            GetVariable = varAddr(i)
            lFound = True
        End If
    Next i
    If Not lFound Then
        AddError "Unknown variable: " & VariableName & "...", CLine
        GetVariable = 0
    End If
End Function

Public Sub AddVariable(Name As String)
    varName(varCount) = Name
    varAddr(varCount) = tmpsize + cAddr + 2
    varCount = varCount + 1
End Sub
